<template>
  <div class="login">
    <div class="system-name">
      <img class="system-logo" src="@/assets/images/logo-white.png" />
      <div>{{ $t('system.name')}} </div>
    </div>
    <el-form ref="loginForm" :model="loginForm" :rules="loginRules" class="login-form" size="middle">
      <div class="login-lang"><lang-select class="set-language" /></div>
      <div class="login-title">
        <img class="login-logo" src="@/assets/images/logomini.png" />
        <div class="login-name">{{ $t('login.title') }}</div>
      </div>
      <el-form-item prop="username">
        <el-input
          v-model="loginForm.username"
          type="text"
          auto-complete="off"
          :placeholder="$t('login.username')"
        >
          <svg-icon slot="prefix" icon-class="user" class="el-input__icon input-icon" />
        </el-input>
      </el-form-item>
      <el-form-item prop="password">
        <el-input
          v-model="loginForm.password"
          type="password"
          auto-complete="off"
          :placeholder="$t('login.password')"
          @keyup.enter.native="handleLogin"
          show-password
        >
          <svg-icon slot="prefix" icon-class="password" class="el-input__icon input-icon" />
        </el-input>
      </el-form-item>
      <!-- <el-form-item prop="code" v-if="captchaEnabled">
        <el-input
          v-model="loginForm.code"
          auto-complete="off"
          :placeholder="$t('login.code')"
          style="width: 63%"
          @keyup.enter.native="handleLogin"
        >
          <svg-icon slot="prefix" icon-class="validCode" class="el-input__icon input-icon" />
        </el-input>
        <div class="login-code">
          <img :src="codeUrl" @click="getCode" class="login-code-img"/>
        </div>
      </el-form-item> -->
      <!-- <el-checkbox v-model="loginForm.rememberMe" style="float: right;margin-bottom:30px">{{ $t('login.rememberMe') }}</el-checkbox> -->
      <el-form-item style="width:100%;margin-top:50px">
        <el-button
          :loading="loading"
         
          type="primary"
          style="width:100%;"
          @click.native.prevent="handleLogin"
        >
          <span v-if="!loading">{{ $t('login.logIn') }}</span>
          <span v-else>{{ $t('login.loginIng') }}</span>
        </el-button>
        <!-- <div style="float: right;" v-if="register">
          <router-link class="link-type" :to="'/register'">立即注册</router-link>
        </div> -->
      </el-form-item>
    </el-form>
    <!--  底部  -->
    <div class="el-login-footer">
      <span>{{ footerContent }}</span>
    </div>
  </div>
</template>

<script>
import LangSelect from '@/components/LangSelect'
import { getCodeImg } from "@/api/login";
import Cookies from "js-cookie";
import { encrypt, decrypt } from '@/utils/jsencrypt'
import defaultSettings from '@/settings'

export default {
  name: "Login",
  components: { LangSelect },
  data() {
    return {
      title: process.env.VUE_APP_TITLE,
      footerContent: defaultSettings.footerContent,
      codeUrl: "",
      loginForm: {
        username: "",
        password: "",
        rememberMe: false,
        code: "",
        uuid: "",
        force:false
      },
      loginRules: {
        username: [
          { required: true, trigger: "blur", message: this.$t('login.usernameRequired') }
        ],
        password: [
          { required: true, trigger: "blur", message: this.$t('login.passwordRequired') }
        ],
        code: [{ required: true, trigger: "change", message: this.$t('login.codeRequired') }]
      },
      loading: false,
      // 验证码开关
      captchaEnabled: true,
      // 注册开关
      register: false,
      redirect: undefined
    }
  },
  watch: {
    $route: {
      handler: function(route) {
        this.redirect = route.query && route.query.redirect;
      },
      immediate: true
    }
  },
  created() {
    this.getCode();
    // this.getCookie();
  },
  methods: {
    getCode() {
      getCodeImg().then(res => {
        this.captchaEnabled = res.captchaEnabled === undefined ? true : res.captchaEnabled;
        if (this.captchaEnabled) {
          this.codeUrl = "data:image/gif;base64," + res.img;
          this.loginForm.uuid = res.uuid;
        }
      });
    },
    getCookie() {
      const username = Cookies.get("username");
      const password = Cookies.get("password");
      const rememberMe = Cookies.get('rememberMe')
      this.loginForm = {
        username: username === undefined ? this.loginForm.username : username,
        password: password === undefined ? this.loginForm.password : decrypt(password),
        rememberMe: rememberMe === undefined ? false : Boolean(rememberMe),
        force:false
      };
    },
    handleLogin() {
      this.$refs.loginForm.validate(valid => {
        if (valid) {
          this.loading = true;
          if (this.loginForm.rememberMe) {
            Cookies.set("username", this.loginForm.username, { expires: 30 });
            Cookies.set("password", encrypt(this.loginForm.password), { expires: 30 });
            Cookies.set('rememberMe', this.loginForm.rememberMe, { expires: 30 });
          } else {
            Cookies.remove("username");
            Cookies.remove("password");
            Cookies.remove('rememberMe');
          }
          this.$store.dispatch("Login", this.loginForm).then((url) => {
            this.$router.push({ path: url }).catch(()=>{});
          }).catch(err => {
            if(err && err.message==='exists'){
              this.$confirm(this.$t('system.crowdOut'), this.$t('system.tip'), {
                confirmButtonText: this.$t('form.confirm'),
                cancelButtonText: this.$t('form.cancel'),
                type: 'warning'
              }).then(() => {
                this.loginForm.force = true
                this.handleLogin()
              }).catch(() => {
                this.loading = false;
                this.loginForm.force = false
                if (this.captchaEnabled) {
                  this.getCode();
                }
              })
            }else{
              this.loading = false;
              this.loginForm.force = false
              if (this.captchaEnabled) {
                this.getCode();
              }
            }
            
          });
        }
      });
    }
  }
};
</script>

<style rel="stylesheet/scss" lang="scss" scoped>
.login {
  display: flex;
  justify-content: center;
  align-items: center;
  height: 100%;
  background-image: url("../assets/images/login-background.jpg");
  background-size: cover;
  .system-name{
    position: absolute;
    left: 60px;
    top:60px;
    color: #fff;
    font-size: 30px;
    display: flex;
    flex-direction: row;
    align-items: center;
    .system-logo{
      height: 31px;
      margin-right: 20px;
    }
  }
}
.title {
  margin: 0px auto 30px auto;
  text-align: center;
  color: #707070;
}

.login-form {
  border-radius: 6px;
  background: #ffffff;
  right: 220px;
  position: absolute;
  padding: 20px 40px 30px 40px;
  z-index: 1;
  .login-lang{
    text-align: right;
    margin-bottom: 20px;
  }
  .login-title{
    display: flex;
    flex-direction: row;
    align-items: center;
    justify-content: center;
    margin-bottom: 35px;
    .login-logo{
      width: 70px;
      margin-right: 20px;
      flex-flow: 0;
    }
    .login-name{
      flex-flow: 0;
      font-weight: bold;
    }


  }
  .el-input {
    height: 38px;
    width: 270px;
    input {
      height: 38px;
    }
  }
  .input-icon {
    height: 39px;
    width: 14px;
    margin-left: 2px;
  }
}
.login-tip {
  font-size: 13px;
  text-align: center;
  color: #bfbfbf;
}
.login-code {
  width: 33%;
  height: 38px;
  float: right;
  img {
    cursor: pointer;
    vertical-align: middle;
  }
}
.el-login-footer {
  height: 40px;
  line-height: 40px;
  position: fixed;
  bottom: 0;
  width: 100%;
  text-align: center;
  color: #fff;
  font-family: Arial;
  font-size: 12px;
  letter-spacing: 1px;
}
.login-code-img {
  height: 38px;
}
</style>